diff -ur rover-0.4.2/rover.c tmp/rover-0.4.2/rover.c
--- rover-0.4.2/rover.c	2016-06-04 06:45:31.000000000 -0700
+++ rover-0.4.2/rover.c	2016-06-19 20:13:14.007843088 -0700
@@ -317,6 +317,31 @@
     }
 }
 
+static void
+shell_escaped_cat(char *buf, char *str, size_t n)
+{
+    char *p = buf + strlen(buf);
+    *p++ = '\'';
+    for (n--; n; n--, str++) {
+        switch (*str) {
+        case '\'':
+            if (n < 4)
+                goto done;
+            strcpy(p, "'\\''");
+            n -= 4;
+            p += 4;
+            break;
+        case '\0':
+            goto done;
+        default:
+            *p = *str;
+            p++;
+        }
+    }
+done:
+    strncat(p, "'", n);
+}
+
 static int
 open_with_env(const char *env, char *path)
 {
@@ -325,7 +350,7 @@
 #ifdef RV_SHELL
         strncpy(BUF1, program, BUFLEN - 1);
         strncat(BUF1, " ", BUFLEN - strlen(program) - 1);
-        strncat(BUF1, path, BUFLEN - strlen(program) - strlen(path) - 2);
+        shell_escaped_cat(BUF1, path, BUFLEN - strlen(program) - 2);
         spawn((char *[]) {RV_SHELL, "-c", BUF1, NULL});
 #else
         spawn((char *[]) {program, path, NULL});
